#include <windows.h>
#include "_6502m.h"
#include "_6502m_p.h"

FCEmu :: FCEmu()
{
	d.Pram = new BYTE[0x08000];
#ifdef MEMORY_CHECK
	d.Pramc = new BYTE[0x08000];
#endif
	Initialize();
}
void FCEmu :: ClearRegister()
{
	d.reg.a  = 0x00;
	d.reg.x  = 0x00;
	d.reg.y  = 0x00;
	d.reg.s  = 0xFF;
	d.reg.pc = 0x0000;
int i;

#ifdef TRACER_ENABLED
	for( i=0 ; i<TRACE_SIZE ; i++)trace_buffer[i]=0;
	trace_point = 0;
#endif
}

void FCEmu :: Initialize()
{
	ClearRegister();
int i;
#ifdef MEMORY_CHECK
	for( i=0 ; i<0x8000 ; i++)d.Pramc[i]=0;
#endif
}
void FCEmu :: Release()
{
	delete d.Pram;
#ifdef MEMORY_CHECK
	delete d.Pramc;
#endif
}
