#include <windows.h>
#include <assert.h>
#include <stdio.h>
#include "_6502m.h"
#include "_6502m_p.h"
#include "_6502m_macro.h"

inline BYTE GetROMatPC( DataSet *Pd )
{
	if( Pd->reg.pc >= 0x8000 )
		return Pd->Pprg[Pd->reg.pc/0x2000-4][Pd->reg.pc%0x2000] ;
	else
		return Pd->Pram[Pd->reg.pc] ;
}
inline BYTE GetROMatPCinc( DataSet *Pd )
{
BYTE tb=GetROMatPC( Pd );
	Pd->reg.pc++;
	return tb;
}
//AgԈႦđςȂƂɂȂ
inline  int TAdr2Mem( int adr )
{
	if( adr < 0x8000 )
	{
		return adr ;
	}
	return -1;
}

//́A݌떂
#ifdef MEMORY_CHECK
#include "mymemorymanage.h"
#include "nnsys.h"
#include <io.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
static char hextable[17] = "0123456789ABCDEF";
static char *Int2Hex32(unsigned int data,int ub)
{
static char buf[10][9];
	buf[ub][0] = hextable[(data>>28)];
	buf[ub][1] = hextable[(data>>24)&0x0F];
	buf[ub][2] = hextable[(data>>20)&0x0F];
	buf[ub][3] = hextable[(data>>16)&0x0F];
	buf[ub][4] = hextable[(data>>12)&0x0F];
	buf[ub][5] = hextable[(data>> 8)&0x0F];
	buf[ub][6] = hextable[(data>> 4)&0x0F];
	buf[ub][7] = hextable[(data>> 0)&0x0F];
	buf[ub][8] = '\0';
	return buf[ub];
}
#endif

inline BYTE READ( DataSet *Pd , WORD adr )
{
#ifdef MEMORY_CHECK
int tm;
	tm = TAdr2Mem( adr );
	if( tm != -1 && Pd->Pramc[tm] == 0)
	{
		static FILE *fp ;
		if( !fp ) fopen_s( &fp , "memorytest.txt" , "wt" ) ;
		Pd->Pramc[tm] = 1;
	}
#endif
	if( adr >= 0x8000 )
	{
		return Pd->Pprg[adr/0x2000-4][adr%0x2000] ;
	}
	return Pd->Pram[adr] ;
/*
	//}bvWJ[`ʂ߂̌
	switch( adr )
	{
	case 0x002140:return 0xAA;
	case 0x002141:return 0xBB;
	}
	*/
	return 0;//
}
inline void WRITE( DataSet *Pd , int adr , BYTE data)
{
#ifdef MEMORY_CHECK
int tm;
	tm = TAdr2Mem( adr );
	if( tm != -1 )
	{
		Pd->Pramc[tm] = 1;
	}
#endif
	if( adr>=0x8000 )
	{
		switch( adr )
		{
		case 0x8000:
			Pd->MMC3command = data ;
		break;
		case 0x8001:
			switch( Pd->MMC3command & 0x07 )
			{
			case 6:
				if( Pd->MMC3command & 0x40 )
				{
					Pd->prgNO[2] = data ;
					Pd->Pprg[2] = &Pd->Prom[0x10+(data&0x3F)*0x2000];
				}
				else
				{
					Pd->prgNO[0] = data ;
					Pd->Pprg[0] = &Pd->Prom[0x10+(data&0x3F)*0x2000];
				}
			break;
			case 7:
				if( Pd->MMC3command & 0x40 )
				{
					Pd->prgNO[1] = data ;
					Pd->Pprg[1] = &Pd->Prom[0x10+(data&0x3F)*0x2000];
				}
				else
				{
					Pd->prgNO[1] = data ;
					Pd->Pprg[1] = &Pd->Prom[0x10+(data&0x3F)*0x2000];
				}
			break;
			default:
				;
				//܂
			//	assert(0);
			}
		break;
		//ȉA
		case 0xA000:
		case 0xA001:
		case 0xC000:
		case 0xC001:
		case 0xE000:
		case 0xE001:
		break;
		default:
			throw(EMSG_ROM_WRITE);
		}
	}
	else
	{
		Pd->Pram[adr] = data ;
	}
	return;
}
inline BYTE *GetMemoryPointer(  DataSet *Pd , int adr )
{
	if( adr < 0x8000 )
	{
		return &Pd->Pram[adr];
	}
	return &Pd->DUMMY_BYTE;
}


////////////////////////////////////////////////////////////////

inline void LDA( DataSet *Pd , BYTE data )
{
	Pd->reg.a = data;
	TESTA();
}
inline void LDX( DataSet *Pd , BYTE data )
{
	Pd->reg.x = data;
	TESTX();
}
inline void LDY( DataSet *Pd , BYTE data )
{
	Pd->reg.y = data;
	TESTY();
}
inline void STA( DataSet *Pd , int adr  )
{
	WRITE( Pd , adr , Pd->reg.a );
}
inline void STX( DataSet *Pd , int adr  )
{
	WRITE( Pd , adr , Pd->reg.x );
}
inline void STY( DataSet *Pd , int adr  )
{
	WRITE( Pd , adr , Pd->reg.y );
}
inline void INC( DataSet *Pd , int adr )
{
WORD tw;
	tw = READ( Pd , adr );
	tw++;
	WRITE( Pd , adr , (BYTE)tw );
	TEST((BYTE)tw);
	if(tw==0x0100)SET_F(FLAG_C);
}
inline void INCA( DataSet *Pd )
{
/*	if( IS8A )
	{
		Pd->reg.a.b.l ++;
		TESTA();
		if( Pd->reg.a.b.l == 0x00 )SET_F(FLAG_C);//vȂ
	}
	else
	{
		Pd->reg.a.w ++;
		TESTA();
		if( Pd->reg.a.b.l == 0x0000 )SET_F(FLAG_C);//vȂ
	}
*/}

inline void DEC( DataSet *Pd , int adr )
{
WORD tw;
	tw = READ( Pd , adr );
	tw--;
	WRITE( Pd , adr , (BYTE)tw );
	TEST((BYTE)tw);
	if(tw==0xFFFF)CLR_F(FLAG_C);
	else SET_F(FLAG_C);
}
inline void INX( DataSet *Pd)
{
	if(Pd->reg.x==0xFF)SET_F(FLAG_C);
	Pd->reg.x++;
	TESTX();
}
inline void INY( DataSet *Pd)
{
	if(Pd->reg.y==0xFF)SET_F(FLAG_C);
	Pd->reg.y++;
	TESTY();
}
inline void DEX( DataSet *Pd)
{
	if(Pd->reg.x==0x00)CLR_F(FLAG_C);
	else SET_F(FLAG_C);
	Pd->reg.x--;
	TESTX();
}
inline void DEY( DataSet *Pd)
{
	if(Pd->reg.y==0x00)CLR_F(FLAG_C);
	else SET_F(FLAG_C);
	Pd->reg.y--;
	TESTY();
}
inline void CMPcommon( DataSet *Pd , BYTE regv , BYTE data )
{
	PCLEAR;
	CLR_F( FLAG_C );
int ti;
	ti = regv - data ;
	if( ti>=0 )SET_F(FLAG_C);
	if( ti==0 )SET_F(FLAG_Z);
	if( (BYTE)ti &0x80 )SET_F(FLAG_N);
}
inline void CMP( DataSet *Pd , BYTE data)
{
	CMPcommon( Pd , Pd->reg.a , data ) ;
}
inline void CPX( DataSet *Pd , BYTE data)
{
	CMPcommon( Pd , Pd->reg.x , data ) ;
}
inline void CPY( DataSet *Pd , BYTE data)
{
	CMPcommon( Pd , Pd->reg.y , data ) ;
}
inline void BIT( DataSet *Pd , BYTE data )
{
	PCLEAR;
	CLR_F( FLAG_C );
	TEST(Pd->reg.a & data);
}


inline void ADC( DataSet *Pd , BYTE data )
{
	PCLEAR;
BYTE fl1=0;
int ti;
	if(Pd->reg.p&FLAG_C)fl1=1;
	CLR_F(FLAG_C);

	ti = Pd->reg.a + data + fl1 ;
	if( ti >= 0x0100)SET_F(FLAG_C);
	if( ti==0 )SET_F(FLAG_Z);
	if( ti&0x80 )SET_F(FLAG_N) ;

	if( !((Pd->reg.a^data)&0x80) )
	{//A
		if( data&0x80 )
		{
			if( (ti&0x80) )SET_F(FLAG_V) ;
		}
		else
		{
			if( !(ti&0x80) )SET_F(FLAG_V) ;
		}
	}
	Pd->reg.a = (BYTE)ti;
}
inline void SBC( DataSet *Pd , BYTE data )
{
BYTE c1;
	c1=1;
	if(Pd->reg.p&FLAG_C)c1=0;

	PCLEAR;
	CLR_F(FLAG_C);
int ti;
	ti = Pd->reg.a - data - c1 ;
	if( ti >= 0 )SET_F(FLAG_C);
	if( ti == 0 )SET_F(FLAG_Z);
	if( ti & 0x80 )SET_F(FLAG_N) ;
	if( ((Pd->reg.a^data)&0x80) )
	{//ٕ
		if( data&0x80 )
		{
			if( !(ti&0x80) )SET_F(FLAG_V) ;
		}
		else
		{
			if(  (ti&0x80) )SET_F(FLAG_V) ;
		}
	}

	Pd->reg.a = (BYTE)(ti);
}
inline void ASL( DataSet *Pd , BYTE *Ptr)
{
	CLR_F(FLAG_C);
	if( *Ptr & 0x80 )SET_F(FLAG_C);
	*Ptr <<= 1;
}
inline void LSR( DataSet *Pd , BYTE *Ptr)
{
	CLR_F(FLAG_C);
	if( *Ptr & 0x01 )SET_F(FLAG_C);
	*Ptr >>= 1;
}
inline void ROL( DataSet *Pd , BYTE *Ptr )
{
BYTE c1;
	c1 = 0;
	if( Pd->reg.p & FLAG_C ) c1 = 1;
	CLR_F(FLAG_C);
	if( *Ptr & 0x80 )SET_F(FLAG_C);
	*Ptr <<= 1;
	*Ptr |= c1;
}
inline void ROR( DataSet *Pd  , BYTE *Ptr )
{
BYTE c1;
	c1 = 0;
	if( Pd->reg.p & FLAG_C ) c1 = 0x80;
	CLR_F(FLAG_C);
	if( *Ptr & 0x01 )SET_F(FLAG_C);
	*Ptr >>= 1;
	*Ptr |= c1;
}
inline void ORA( DataSet *Pd , BYTE data )
{
	Pd->reg.a |= data;
	TESTA();
}
inline void AND( DataSet *Pd , BYTE data )
{
	Pd->reg.a &= data;
	TESTA();
}
inline void EOR( DataSet *Pd , BYTE data )
{
	Pd->reg.a ^= data;
	TESTA();
}
inline void PHA(DataSet *Pd )
{
	Pd->Pram[ 0x100+Pd->reg.s ] = Pd->reg.a;
	Pd->reg.s--;
	if( Pd->reg.s == 0x00 )throw EMSG_STACK_O;
	//̎_ł̓Z[tł́H
}
inline void PHP( DataSet *Pd )
{
	Pd->Pram[ 0x100+Pd->reg.s ] = Pd->reg.p;
	Pd->reg.s--;
	if( Pd->reg.s == 0x00 )throw EMSG_STACK_O;
}
inline void PLA( DataSet *Pd )
{
	if( Pd->reg.s == 0xFF )throw EMSG_STACK_N;
	Pd->reg.s++;
	Pd->reg.a = Pd->Pram[ 0x100+Pd->reg.s];
	TESTA();
}
inline void PLP( DataSet *Pd )
{
	if( Pd->reg.s == 0xFF )throw EMSG_STACK_N;
	Pd->reg.s++;
	Pd->reg.p = Pd->Pram[ 0x100+Pd->reg.s];
}
inline void JSR( DataSet *Pd , int adr )
{

	Pd->reg.pc--;
	if( Pd->reg.s == 0x00 )throw EMSG_STACK_O;
	Pd->Pram[ 0x100+Pd->reg.s  ] = Pd->reg.pc>>8;
	Pd->Pram[ 0x100+Pd->reg.s-1] = Pd->reg.pc&0xFF;
	Pd->reg.s-=2;
	Pd->reg.pc = adr ;
}
inline void RTS( DataSet *Pd )
{
	if( Pd->reg.s == 0xFF )
	{
		Pd->reg.pc--;//͗]vȋC
		throw EMSG_EOS ;
	}
	if( Pd->reg.s == 0xFE )
	{
		throw EMSG_STACK_N ;
	}

	Pd->reg.pc = (Pd->Pram[ 0x100+Pd->reg.s+2] << 8 )| Pd->Pram[ 0x100+Pd->reg.s+1] ;
	Pd->reg.pc++;
	Pd->reg.s += 2;
}
inline void JMP( DataSet *Pd , WORD adr )
{
	Pd->reg.pc = adr ;
}

///////////////////////////////////////////////////////////////////////









inline BYTE Immediate8( DataSet *Pd )
{
	return GetROMatPCinc( Pd ) ;
}
inline WORD Immediate16( DataSet *Pd )
{
WORD tw=GetROMatPCinc( Pd );
	return tw|(GetROMatPCinc( Pd )<<8);
}
inline BYTE Zeropage( DataSet *Pd )
{
	return GetROMatPCinc( Pd );
}
inline WORD ZeropageIndexX( DataSet *Pd )
{
	return GetROMatPCinc( Pd )+Pd->reg.x;
}
inline WORD ZeropageIndexY( DataSet *Pd )
{
	return GetROMatPCinc( Pd )+Pd->reg.y;
}
inline WORD AbsoluteAddress( DataSet *Pd , int offset = 0 )
{
int ti;
	ti = GetROMatPCinc( Pd ) ;
	return ( ti | (GetROMatPCinc( Pd ) << 8) ) + offset;
}
inline WORD AbsoluteAddressIndexX( DataSet *Pd )
{
	return AbsoluteAddress( Pd , Pd->reg.x ) ;
}
inline WORD AbsoluteAddressIndexY( DataSet *Pd )
{
	return AbsoluteAddress( Pd , Pd->reg.y ) ;
}
inline WORD Indirect( DataSet *Pd )
{
WORD tw,tw2;
	tw = GetROMatPCinc( Pd ) ;
	tw |= GetROMatPCinc( Pd )<<8 ;
	tw2 = READ( Pd , tw ) ;
	tw2 |= READ( Pd , tw+1 ) << 8 ;
	return tw2 ;
}
inline WORD IndirectX( DataSet *Pd )
{
WORD tw,tw2;
	tw = GetROMatPCinc( Pd ) ;
	tw += Pd->reg.x ;
	tw2 = READ( Pd , tw ) ;
	tw2 |= READ( Pd , tw+1 ) << 8 ;
	return tw2 ;
}
inline WORD IndirectY( DataSet *Pd )
{
WORD tw,tw2;
	tw = GetROMatPCinc( Pd ) ;
	tw2 = READ( Pd , tw ) ;
	tw2 |= READ( Pd , tw+1 ) << 8 ;
	tw2 += Pd->reg.y ;
	return tw2 ;
}

#include "_6502m_op0123.h"
#include "_6502m_op4567.h"
#include "_6502m_op89AB.h"
#include "_6502m_opCDEF.h"





void OPXX( DataSet *Pd )
{
	throw EMSG_ND;
}




void (*PAFuncPerOp[0x0100])(DataSet* Pd)=
{
	OP00,OP01,OPXX,OPXX,OPXX,OP05,OP06,OPXX,OP08,OP09,OP0A,OPXX,OPXX,OP0D,OP0E,OPXX,
	OP10,OP11,OPXX,OPXX,OPXX,OP15,OP16,OPXX,OP18,OP19,OPXX,OPXX,OPXX,OP1D,OP1E,OPXX,
	OP20,OP21,OPXX,OPXX,OP24,OP25,OP26,OPXX,OP28,OP29,OP2A,OPXX,OP2C,OP2D,OP2E,OPXX,
	OP30,OP31,OPXX,OPXX,OPXX,OP35,OP36,OPXX,OP38,OP39,OPXX,OPXX,OPXX,OP3D,OP3E,OPXX,
	OP40,OP41,OPXX,OPXX,OPXX,OP45,OP46,OPXX,OP48,OP49,OP4A,OPXX,OP4C,OP4D,OP4E,OPXX,
	OP50,OP51,OPXX,OPXX,OPXX,OP55,OP56,OPXX,OP58,OP59,OPXX,OPXX,OPXX,OP5D,OP5E,OPXX,
	OP60,OP61,OPXX,OPXX,OPXX,OP65,OP66,OPXX,OP68,OP69,OP6A,OPXX,OP6C,OP6D,OP6E,OPXX,
	OP70,OP71,OPXX,OPXX,OPXX,OP75,OP76,OPXX,OP78,OP79,OPXX,OPXX,OPXX,OP7D,OP7E,OPXX,
	OPXX,OP81,OPXX,OPXX,OP84,OP85,OP86,OPXX,OP88,OPXX,OP8A,OPXX,OP8C,OP8D,OP8E,OPXX,
	OP90,OP91,OPXX,OPXX,OP94,OP95,OP96,OPXX,OP98,OP99,OP9A,OPXX,OPXX,OP9D,OPXX,OPXX,
	OPA0,OPA1,OPA2,OPXX,OPA4,OPA5,OPA6,OPXX,OPA8,OPA9,OPAA,OPXX,OPAC,OPAD,OPAE,OPXX,
	OPB0,OPB1,OPXX,OPXX,OPB4,OPB5,OPB6,OPXX,OPB8,OPB9,OPBA,OPXX,OPBC,OPBD,OPBE,OPXX,
	OPC0,OPC1,OPXX,OPXX,OPC4,OPC5,OPC6,OPXX,OPC8,OPC9,OPCA,OPXX,OPCC,OPCD,OPCE,OPXX,
	OPD0,OPD1,OPXX,OPXX,OPXX,OPD5,OPD6,OPXX,OPD8,OPD9,OPXX,OPXX,OPXX,OPDD,OPDE,OPXX,
	OPE0,OPE1,OPXX,OPXX,OPE4,OPE5,OPE6,OPXX,OPE8,OPE9,OPEA,OPXX,OPEC,OPED,OPEE,OPXX,
	OPF0,OPF1,OPXX,OPXX,OPXX,OPF5,OPF6,OPXX,OPF8,OPF9,OPXX,OPXX,OPXX,OPFD,OPFE,OPXX,
};



void FCEmu :: OprateOnce()
{
#ifdef TRACER_ENABLED
	trace_buffer[trace_point] = (d.prgNO[d.reg.pc/0x2000-4]<<16)|d.reg.pc;
	trace_point++;
	trace_point %= TRACE_SIZE ;
#endif

#ifdef _DEBUG
	//薽߃u[N
	if( GetROMatPC(&d) == 0x81 )
	{
		int i ;
		i=0 ;
	}
	switch(((d.prgNO[((d.reg.pc&0x7FFF)>>13)]<<16)|d.reg.pc)  )
	{
//	case 0x3EC446:
//	case 0x3EC488:
//	case 0x3EC499:
//	case 0x3EC4AA:
//	case 0x3EC4C9:
//	case 0x3EC4DD:
	case 0x3EC446:
//	case 0x3EC504:
//	case 0x3EC517:
//	case 0x3EC534:
		{
			int i ;
			i=((d.prgNO[((d.reg.pc&0x7FFF)>>13)]<<16)|d.reg.pc) ;
			i=0 ;
		}
	break ;
	}

#endif



	PAFuncPerOp[GetROMatPCinc(&d)](&d) ;
}


void FCEmuMinus :: WriteAdr( int adr , BYTE val )
{
	WRITE( &d , adr , val );
}
void FCEmuMinus :: WriteAdrW(int adr , WORD val )
{
	WRITE( &d , adr , (BYTE)val );
	WRITE( &d , adr+1 , (BYTE)(val>>8) );
}

BYTE FCEmuMinus :: GetAdr( int adr )
{
	return READ( &d , adr );
}