//BRK #**
static void OP00( DataSet* Pd )
{
	throw EMSG_UKOP ;
}

//ORA ($**,X)
static void OP01( DataSet* Pd )
{
	ORA( Pd , READ( Pd , IndirectX( Pd ) ) );
}

//ORA $**
static void OP05( DataSet* Pd )
{
	ORA( Pd , READ( Pd , Zeropage( Pd ) ) ) ;
	
}

//ASL $**
static void OP06( DataSet* Pd )
{
	ASL( Pd , GetMemoryPointer(Pd , Zeropage( Pd ) ));
	
}

//PHP
static void OP08( DataSet* Pd )
{
	PHP( Pd ) ;	
}

//ORA #$**
static void OP09( DataSet* Pd )
{
	ORA( Pd , Immediate8(Pd) );
	
}

//ASL A
static void OP0A( DataSet* Pd )
{
	ASL( Pd , &Pd->reg.a ) ;
}

//ORA $****
static void OP0D( DataSet* Pd )
{
	ORA( Pd , READ( Pd , AbsoluteAddress( Pd ) ) ) ;
	
}

//ASL $****
static void OP0E( DataSet* Pd )
{
	ASL( Pd , GetMemoryPointer( Pd , AbsoluteAddress( Pd ) ) ) ;
	
}

//BPL
static void OP10( DataSet* Pd )
{
BYTE tb=Immediate8(Pd);
	if( !(Pd->reg.p & FLAG_N) )
		Pd->reg.pc += (char)tb;
}

//ORA ($**),y
static void OP11( DataSet* Pd )
{
	ORA( Pd , READ( Pd , IndirectY( Pd ) ) ) ;	
}

//ORA $**,x
static void OP15( DataSet* Pd )
{
	ORA( Pd , READ( Pd , ZeropageIndexX( Pd ) ) ) ;
}

//ASL $**,x
static void OP16( DataSet* Pd )
{
	ASL( Pd , GetMemoryPointer( Pd , ZeropageIndexX( Pd ) ) ) ;
	
}
//CLC
static void OP18( DataSet* Pd )
{
	CLR_F( FLAG_C );
	
}

//ORA $****,y
static void OP19( DataSet* Pd )
{
	ORA( Pd , READ( Pd , AbsoluteAddressIndexY( Pd ) ) ) ;
	
}

//ORA $****,x
static void OP1D( DataSet* Pd )
{
	ORA( Pd , READ( Pd , AbsoluteAddressIndexX( Pd ) ) ) ;
	
}

//ASL $****,x
static void OP1E( DataSet* Pd )
{
	ASL( Pd , GetMemoryPointer( Pd , AbsoluteAddressIndexX( Pd ) ) ) ;
	
}

//JSR $****
static void OP20( DataSet* Pd )
{
	JSR( Pd , Immediate16( Pd ) );
	
}

//AND ($**,x)
static void OP21( DataSet* Pd )
{
	AND( Pd , READ( Pd , IndirectX( Pd ) ) ) ;
	
}

//BIT $**
static void OP24( DataSet* Pd )
{
	BIT( Pd , READ( Pd , Zeropage( Pd ) ) ) ;
	
}

//AND $**
static void OP25( DataSet* Pd )
{
	AND( Pd , READ( Pd , Zeropage( Pd ) ) ) ;
	
}

//ROL $**
static void OP26( DataSet* Pd )
{
	ROL( Pd , GetMemoryPointer( Pd , Zeropage( Pd ) ) );
	
}

//PLP
static void OP28( DataSet* Pd )
{
	PLP( Pd ) ;
}

//AND #**
static void OP29( DataSet* Pd )
{
	AND( Pd , Immediate8( Pd ) );
	
}

//ROL A
static void OP2A( DataSet* Pd )
{
	ROL( Pd , &Pd->reg.a );
	
}

//CMP $****
static void OP2C( DataSet* Pd )
{
	CMP( Pd , READ( Pd , AbsoluteAddress( Pd ) ) );
	
}

//AND $****
static void OP2D( DataSet* Pd )
{
	AND( Pd , READ( Pd , AbsoluteAddress( Pd ) ) ) ;
}

//ROL $****
static void OP2E( DataSet* Pd )
{
	ROL( Pd , GetMemoryPointer( Pd , AbsoluteAddress( Pd ) ) ) ;
	
}

//BMI
static void OP30( DataSet* Pd )
{
BYTE tb=Immediate8(Pd);
	if( Pd->reg.p & FLAG_N )
		Pd->reg.pc += (char)tb;
	
}

//AND ($**),y
static void OP31( DataSet* Pd )
{
	AND( Pd , READ( Pd , IndirectY( Pd ) ) ) ;
	
}

//AND $**,x
static void OP35( DataSet* Pd )
{
	AND( Pd , READ( Pd , ZeropageIndexX( Pd ) ) ) ;
	
}

//ROL $**,x
static void OP36( DataSet* Pd )
{
	ROL( Pd , GetMemoryPointer( Pd , ZeropageIndexX( Pd ) ) ) ;
	
}

//SEC
static void OP38( DataSet* Pd )
{
	Pd->reg.p |= FLAG_C;
}

//AND $****,y
static void OP39( DataSet* Pd )
{
	AND( Pd , READ( Pd , AbsoluteAddressIndexY( Pd ) ) ) ;
}


//AND $****,x
static void OP3D( DataSet* Pd )
{
	AND( Pd , READ( Pd , AbsoluteAddressIndexX( Pd ) ) ) ;
	
}

//ROL $****,x
static void OP3E( DataSet* Pd )
{
	ROL( Pd , GetMemoryPointer( Pd , AbsoluteAddressIndexX( Pd ) ) ) ;
	
}
