#include "packing.h"

Packing :: ~Packing()
{
	//freeׂlߍ݃f[^cĂfree
	PackingData *pTmp ;
	for( int i=0 ; ; i++ )
	{
		pTmp = cvPacking[i] ;
		if( !pTmp )
			{ break ;}
		if( pTmp->iIsFree )
			free( pTmp->pData ) ;
	}
}

bool Packing :: Register( BYTE *pData , int iSize , bool iIsFree , BYTE *pAddr0 ,  BYTE *pAddr1 ,  BYTE *pAddr2 ,  BYTE *pAddr3 )
{
	PackingData *pTmp ;
	pTmp = cvPacking.Add( -iSize ) ; //TCY傫ԂɃ\[g
	if( !pTmp )return false ;
	pTmp->pData   = pData ;
	pTmp->iSize   = iSize ;
	pTmp->iIsFree = iIsFree ;
	pTmp->pAddr[0] = pAddr0 ;
	pTmp->pAddr[1] = pAddr1 ;
	pTmp->pAddr[2] = pAddr2 ;
	pTmp->pAddr[3] = pAddr3 ;
	return true ;
}
bool Packing::RegisterFreeSpace( BYTE *pBase , int iOffset , int iSize )
{
	Packing_FreeSpace *pTmp ;
	pTmp = cvFree.Add( iSize ) ; //TCYԂɃ\[g
	if( !pTmp )return false ;
	pTmp->pBase = pBase ;
	pTmp->iOffset = iOffset ;
	pTmp->iSize = iSize ;
	return true ;
}

bool Packing::Do()
{
	for(;;)
	{
		PackingData *pTmp ;
		pTmp = cvPacking[0] ;
		if( !pTmp )break ; //SĂ̂߂݂
		//ԑ傫ȃTCY̋lߍ݃f[^擾ꂽ

		for( int iFS=0 ; ; iFS++ )
		{
			Packing_FreeSpace *pFS ;
			pFS = cvFree[iFS] ;
			if( !pFS )
			{ //Xy[Xsɂlߍ݂Ɏs
				return false ;
			}
			if( pFS->iSize >= pTmp->iSize )
			{ //KȃXy[X
				unsigned int uiAddr ;
				uiAddr = Offset2Addr( pFS->iOffset ) ;
				memcpy( pFS->pBase + pFS->iOffset , 
						pTmp->pData , pTmp->iSize ) ;

				if( pTmp->pAddr[0] ){ *(pTmp->pAddr[0]) = (uiAddr>> 0)&0xFF ; }
				if( pTmp->pAddr[1] ){ *(pTmp->pAddr[1]) = (uiAddr>> 8)&0xFF ; }
				if( pTmp->pAddr[2] ){ *(pTmp->pAddr[2]) = (uiAddr>>16)&0xFF ; }
				if( pTmp->pAddr[3] ){ *(pTmp->pAddr[3]) = (uiAddr>>24)&0xFF ; }

				//󂫃Xy[XChainedVariable\[g
				//̂߁A폜ĂъmہARs[s
				Packing_FreeSpace PreFS ;
				PreFS = *pFS ;
				cvFree.DeleteWithOrder( iFS ) ;
				if( PreFS.iSize   - pTmp->iSize )
				{
					RegisterFreeSpace( 
						PreFS.pBase , 
						PreFS.iOffset + pTmp->iSize , 
						PreFS.iSize   - pTmp->iSize ) ;
					if( !pTmp )return false ;
				}
				//lߍ݃f[^̍폜
				if( pTmp->iIsFree )
					{free( pTmp->pData ) ; }
				cvPacking.DeleteWithOrder( 0 ) ;
				break ;
			}
		}//iFS(̃Xy[XT)
	}//
	return true ;
}