#include <windows.h>
#include <malloc.h>


#include "ChainedVariable.h"

#ifndef PACKING_HEADER_INCLUDED
#define PACKING_HEADER_INCLUDED


typedef struct Packing_FreeSpace_tag
{
	BYTE *pBase ;
	int  iOffset ;
	int  iSize ;
}Packing_FreeSpace ;

typedef struct PackingData_tag
{
	BYTE *pAddr[4] ;
	BYTE *pData ;
	int  iSize ;
	bool iIsFree ;
}PackingData ;

class Packing
{
public:
	Packing() {;}
	~Packing() ;
	bool Register( BYTE *pData , int iSize , bool iIsFree , BYTE *pAddr0=NULL ,  BYTE *pAddr1=NULL ,  BYTE *pAddr2=NULL ,  BYTE *pAddr3=NULL ) ;
	bool RegisterFreeSpace( BYTE *pBase , int iOffset , int iSize ) ;
	bool Do() ;
protected:
	virtual unsigned int Offset2Addr( int iOffset ){ return iOffset ; }
	ChainedVariable<PackingData> cvPacking ; 
	ChainedVariable<Packing_FreeSpace> cvFree ; 

};

#endif /*PACKING_HEADER_INCLUDED*/