#include "../common.h"

void TaskAppManager::Finit()
{
	TaskObjectManager::Pmdo = &GL::mdo ;
	TaskObjectManager::Prr = GL::RequestRedraw ;

	{//AvP[ṼpX擾
		_TCHAR atcTmp[GL::PATH_SIZE] ;
		if(!GetModuleFileName( NULL , atcTmp , GL::PATH_SIZE ))
		{
			MessageBox( GL::hWnd , _T("Path of application is too long.\nTry to put it in a folder at C:\ root ") , 
									_T("Failed to get path of this application") , MB_OK ) ;
			Suicide() ;
			return;
		}
		tstring strTmp( atcTmp ) ;
		GL::strAppPath = strTmp.substr( 0 , strTmp.rfind( _T('\\') )+1 ) ;
	}

	GL::strProjectPath = _T("") ;
	GL::strRoomPath = _T("roomTMP.dtroom") ;

	GL::mdo.Initialize( GL::hWnd , GL::hInstance );

	if( GL::SafeRomLoad() )
	{
		Suicide() ;
		return ;
	}
	GL::iPrgSize = GL::pucRom[4]*0x4000 ;
	GL::SetupNESColor( GL::FILE_PATH_FCPAL ) ;

	{
		tstring strTmpFileName( GL::strAppPath ) ;
		strTmpFileName += GL::FILE_PATH_OBJNAME ;
		GL::LoadNameTable( GL::astrObjectName , 256 , strTmpFileName.c_str() ) ;
	}
	{
		tstring strTmpFileName( GL::strAppPath ) ;
		strTmpFileName += GL::FILE_PATH_DOORNAME ;
		GL::LoadNameTable( GL::astrDoorName , 128 , strTmpFileName.c_str() ) ;
	}

	//CɎgFODSƁAhAړpɎgFODSm
	//Ȃ񂾂Aꕔ̗vfstaticŊmۂꂽϐLpɂȂĂA
	//HIT_INFÕT[tFCXLƃCC肪肻ǁB
	GL::pFODSW = new FODS( &GL::mdo , GL::NESColor , GL::SFC_CHAR   , GL::SFC_CHIP   , GL::SFC_HIT_INFO , GL::pucRom , GL::iRomSize , 20 ) ;
	GL::mdo.ReleaseSurface( GL::SFC_HIT_INFO ) ;
	GL::pFODSS = new FODS( &GL::mdo , GL::NESColor , GL::SFC_CHAR_S , GL::SFC_CHIP_S , GL::SFC_HIT_INFO , GL::pucRom , GL::iRomSize , -1 ) ;
	GL::pFODSW->pVTE->SetSFCTile( GL::SFC_CHIP ) ;
	{
		tstring strTmpFileName( GL::strAppPath ) ;
		strTmpFileName += GL::FILE_NAME_CLIP ;
		GL::pFODSW->pVTE->SetClipFileName( strTmpFileName ) ;
	}

	new TaskFrameInit( this , TP_FRAMEINIT , true ) ;
	new TaskFrameEnd ( this , TP_FRAMEEND  , true ) ;

	new TaskProjectPathMode( this , TP_PROJECT_PATH_MODE , true ) ;

	iProgress = 100 ;

	return ;
}
void TaskAppManager::Fmain()
{
	switch( iProgress )
	{
	case 100:
		if( !SearchTask( TP_PROJECT_PATH_MODE ) )
		{
			new TaskModeManager( this , TP_MODE_MANAGER , true ) ;
			iProgress = 200 ;
		}
	break ;
	case 200:
	break ;
	}
	return ;
}
void TaskAppManager::Fdest()
{
	if( GL::pFODSW )delete GL::pFODSW ;
	if( GL::pFODSS )delete GL::pFODSS ;
	free( GL::pucRom ) ;
	return ;
}
void TaskAppManager::Fdraw()
{
	return ;
}

void TaskFrameEnd::Fmain()
{
#ifdef _DEBUG
	static int iRD,iFl ; //{ɍtbvĈӖႤȁ[
#endif
	KeyMove();
	if(isredraw)
	{
		GL::mdo.Cls( MDO3normal , 0 , 0 , 0 , GL::WINWIDTH , GL::WINHEIGHT , myRGB(28,31,28) );
		Task0810 *Pptr ;
		Pptr = Task0810::SolveHandle( GL::HAM ) ;
		if( Pptr ) Pptr->DrawCP() ;
		isredraw = 0;
		isflip = 1;

#ifdef _DEBUG
		iRD += 8 ;
		RotateCorrect( &iRD , GL::WINWIDTH ) ;
		GL::mdo.Cls( MDO3normal , 0 , iRD , 0 , 8 , 4 , myRGB(31,0,0) );
#endif
	}
	if(isflip)
	{
#ifdef _DEBUG
		iFl += 8 ;
		RotateCorrect( &iFl , GL::WINWIDTH ) ;
		GL::mdo.Cls( MDO3normal , 0 , iFl , 4 , 8 , 4 , myRGB(31,0,0) );
#endif
		GL::mdo.Flip( MDO3FT_NORMAL );
		isflip = 0;
	}
	return;
}


