#include "../common.h"

#define SUBWINDOW_W		256

void TaskModeDoor::Finit()
{
	{//Tu
		Task0810 *pTask ;
		pTask = new TaskObjectSubWindow( this , true , GL::WINWIDTH-SUBWINDOW_W , 0 , SUBWINDOW_W , GL::WINHEIGHT , myRGB(31,31,31) ) ;
		if( pTask )
		{
			pTask = new TaskModeDoorSub( pTask , true ) ;
			if( pTask )
				{ hSubMode = pTask->GetHandle() ;}
		}
	}


	{
		int iX = 0 ;
		int iY = GL::WINHEIGHT-24 ;
		Task0810 *pTask ;

		hBinaryEditorT = 0 ;
		hBinaryEditorR = 0 ;
		hRotateListT   = 0 ;


#define TEXTINC(str)															\
		new TaskObjectBoxText( this , false , iX , iY , 24 , 12 ,				\
								RGB(0,0,0) , RGB(255,255,255) , str , -1 ) ;	\
		iX += (_countof(str)*24) ;												/**/
		TEXTINC( _T("Type:") ) ;
		pTask = new TaskObjectBinaryEditor( this , true , iX , iY , 24 , (unsigned char*)&iType , 1 , 1 , 1 ) ;
		if( pTask ){ hBinaryEditorT = pTask->GetHandle() ; }
		iX += 12*7 ;
		TEXTINC( _T("Destination:") ) ;
		pTask = new TaskObjectBinaryEditor( this , true , iX , iY , 24 , (unsigned char*)&iDestRoom , 2 , 1 , 1 ) ;
		if( pTask ){ hBinaryEditorR = pTask->GetHandle() ; }
		iX += 12*7 ;

		pTask = new TaskObjectRotateList( this , true , iX , GL::WINHEIGHT-14*11 , 192 , 14 , 11 ,  &iType , GL::astrDoorName , 0x80 ) ;
		if( pTask ){ hRotateListT = pTask->GetHandle() ; }

#undef TEXTINC
	}



	iType = 0 ;
	iDestRoom = 0 ;
	iCurDestRoom = -1 ;
	iDestP = 0 ;
	iDestX = 0 ;
	iDestY = 0 ;
	iDestChanged = 0 ;
	iPreSelectedToken = -1 ;

	GL::pFODSW->DoorUnit.InitEditing() ;
	SetProcessOrderPandC( false , true ) ;
	SetDrawOrderPandC( true , false ) ;
	return ;
}
void TaskModeDoor::Fmain()
{
	{//oCiGfB^⃊Xgɓ͂ꂽf[^g[Nɔf
		Task0810 *pTask ;
		{
			bool bUpdate = false ;
			if( pTask = Task0810::SolveHandle( hBinaryEditorT ) )
				{ bUpdate |= ((TaskObjectBinaryEditor*)pTask)->IsChanged() ; }
			if( pTask = Task0810::SolveHandle( hRotateListT ) )
				{ bUpdate |= ((TaskObjectRotateList*)pTask)->IsChanged() ; }
			if( bUpdate )
			{
				GL::pFODSW->DoorUnit.Modify( -1 , -1 , iType , -1 , -1 , -1 , -1 ) ;
				GL::iUpdatedRoom |= GL::pFODSW->IsDoorPooled() ;
				GL::RequestRedraw() ;
			}
		}
		if( (pTask = Task0810::SolveHandle( hBinaryEditorR )) &&
			((TaskObjectBinaryEditor*)pTask)->IsChanged() )
		{
			GL::pFODSW->DoorUnit.Modify( -1 , -1 , -1 , iDestRoom , -1 , -1 , -1 ) ;
			GL::iUpdatedRoom |= GL::pFODSW->IsDoorPooled() ;
			GL::RequestRedraw() ;
		}
		if( iDestChanged )
		{
			iDestChanged = 0 ;
			GL::pFODSW->DoorUnit.Modify( -1 , -1 , -1 , -1 , iDestP , iDestX , iDestY ) ;
			GL::iUpdatedRoom |= GL::pFODSW->IsDoorPooled() ;
			GL::RequestRedraw() ;
		}
	}
	

	{//g[ÑGfBeBOs
		int iX , iY ;
		Task0810::GetGlobalPosition( &iX , &iY , 2 ) ;
		if( GL::pFODSW->DoorUnit.DoEdit( iX , iY ) )
		{
			GL::iUpdatedRoom |= GL::pFODSW->IsDoorPooled() ;
			GL::RequestRedraw() ;
		}
	}



	{ //PIɁAoCiGfB^ƃXgXV
		int iTmp ;
		iTmp = GL::pFODSW->DoorUnit.GetType() ;
		if( iTmp >= 0 && iTmp != iType )
		{
			iType = iTmp ;
			GL::RequestRedraw() ;
		}
		int iDP , iDX , iDY ;
		if( GL::pFODSW->DoorUnit.GetDestValue( &iTmp , &iDP , &iDX , &iDY ) && 
			( iTmp != iDestRoom || iDP != iDestP || iDX != iDestX || iDY != iDestY ) )
		{
			iDestRoom = iTmp ;
			iDestP = iDP ;
			iDestX = iDX ;
			iDestY = iDY ;
			GL::RequestRedraw() ;
		}	
	}



	int DoSeekDoor = 0 ;

	if( VAR_LET( iCurDestRoom , iDestRoom ) )
	{ //݂̃Tu̕ƁAiDestRoomقȂƂ[hs
		GL::LoadRoom( GL::pFODSS , iDestRoom ) ;
		GL::pFODSS->DrawChr() ;
		GL::pFODSS->DrawChip( 0 ) ;

		DoSeekDoor = 1 ;
	}

	{
		int iTmp ;
		iTmp = GL::pFODSW->DoorUnit.GetSelectedSuffix() ;
		if( iTmp>=0 && VAR_LET( iPreSelectedToken , iTmp ) )
			{ DoSeekDoor = 1 ; }
	}

	if( DoSeekDoor )
	{//Tüʒu𒲐
		TaskModeDoorSub *pTask = (TaskModeDoorSub*)SolveHandle( hSubMode ) ;
		if( pTask )
		{
			unsigned char ucRW ;
			GL::pFODSS->GetRoomParameter( &ucRW , NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL ) ;
			int tx , ty ;
			tx = iDestX + iDestP%ucRW*FODS_CHIP_P_PAGE_W ;
			ty = iDestY + iDestP/ucRW*FODS_CHIP_P_PAGE_H ;
			tx *= FODS_TILE_SIZE ;
			ty *= FODS_TILE_SIZE ;

			tx = - tx + (SUBWINDOW_W-FODS_TILE_SIZE)/2 ;
			ty = - ty + (GL::WINHEIGHT-FODS_TILE_SIZE)/2 ;
			DurCorrect( &tx , SUBWINDOW_W-ucRW*FODS_CHIP_P_PAGE_W*FODS_TILE_SIZE , 0 ) ;
			if( ty>=0 ){ ty=0 ; }
			pTask->SetPosition( tx , ty ) ;
		}
		GL::RequestRedraw() ;
	}
		
	return ;
}
void TaskModeDoor::Fdest()
{
	return ;
}
void TaskModeDoor::Fdraw()
{
	int iX , iY ;
	Task0810::GetGlobalPosition( &iX , &iY , 2 ) ;
	GL::pFODSW->DoorUnit.Draw( &GL::mdo , GL::SFC_BACK , iX , iY ) ;
	if( !GL::pFODSW->IsDoorPooled() )
	{
		GL::BoxMoji( GL::SFC_BACK , _T("The door in this room is not pooled") ,
			10 , GL::WINHEIGHT/2-24 , 24 , 12 , RGB(255,255,255) ) ;
		GL::BoxMoji( GL::SFC_BACK , _T("Cannot save") ,
			10 , GL::WINHEIGHT/2  , 24 , 12 , RGB(255,255,255) ) ;
	}
	{
		_TCHAR atcTmp[128] ;
		_stprintf_s( atcTmp , _countof(atcTmp) , _T("Door mode Room:%03d[%03X]") , GL::iCurRoom , GL::iCurRoom ) ;
		SetWindowText( GL::hWnd , atcTmp ) ;
	}
	return ;
}

void TaskModeDoorSub::Finit()
{
}
void TaskModeDoorSub::Fmain()
{
	int iX , iY ;
	GetGlobalPosition( &iX , &iY , 2 ) ;
	GL::pFODSS->SetViewPosition( iX , iY ) ;
	if( KeyScroll( &x , KC_AR , KC_AL , 64 , 8 , 0 ) )
		{ GL::RequestRedraw() ; InvalidateKey() ; }
	if( KeyScroll( &y , KC_AD , KC_AU , 64 , 8 , 0 ) )
		{ GL::RequestRedraw() ; InvalidateKey() ; }

	TASKHANDLE hTaskW = GetParentHandle() ;
	Task0810 *pTaskW = SolveHandle( hTaskW ) ;
	if( pTaskW && ((TaskObjectSubWindow*)pTaskW)->IsInWindow( GetMousePosX() , GetMousePosY() , 1 ) )
	{
		int mx , my ;
		unsigned char ucRW,ucRH ;
		GetGlobalPosition( &iX , &iY , 2 ) ;
		mx = GetMousePosX() - iX ;
		my = GetMousePosY() - iY ;
		mx = GaussDivision( mx , FODS_TILE_SIZE ) ;
		my = GaussDivision( my , FODS_TILE_SIZE ) ;
		GL::pFODSS->GetRoomParameter( &ucRW , &ucRH , NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL ) ;
		if( mx>=0 && mx<ucRW*FODS_CHIP_P_PAGE_W &&
			my>=0 && my<ucRH*FODS_CHIP_P_PAGE_H )
		{
			if( MouseOn( MB_L ) )
			{
				InvalidateMouse() ;
				TASKHANDLE hTask ;
				Task0810 *pTask ;
				if( ( hTask = GetParentHandle() ) &&
					( pTask = SolveHandle( hTask ) ) &&
					( hTask = pTask->GetParentHandle() ) &&
					( pTask = SolveHandle( hTask ) ) )
				{
					int iDP , iDX , iDY ;
					int tDP , tDX , tDY ;
					((TaskModeDoor*)pTask)->GetDestPXY( &iDP , &iDX , &iDY ) ;	
					tDP = mx/FODS_CHIP_P_PAGE_W + my/FODS_CHIP_P_PAGE_H*ucRW ;
					tDX = mx%FODS_CHIP_P_PAGE_W ;
					tDY = my%FODS_CHIP_P_PAGE_H ;
					if( iDP!=tDP || iDX!=tDX || iDY!=tDY )
					{
						((TaskModeDoor*)pTask)->SetDestPXY( tDP , tDX , tDY ) ;	
						GL::RequestRedraw() ;
					}
				}
			}
		}
	}
}
void TaskModeDoorSub::Fdest()
{

}
void TaskModeDoorSub::Fdraw()
{
	int iX , iY ;
	GetGlobalPosition( &iX , &iY , 2 ) ;
	GL::pFODSS->SetViewPosition( iX , iY ) ;
	GL::pFODSS->DrawRoom( GL::SFC_BACK ) ;

	{
		TASKHANDLE hTask ;
		Task0810 *pTask ;
		if( ( hTask = GetParentHandle() ) &&
			( pTask = SolveHandle( hTask ) ) &&
			( hTask = pTask->GetParentHandle() ) &&
			( pTask = SolveHandle( hTask ) ) )
		{
			int iDP , iDX , iDY ;
			unsigned char ucRW ;
			((TaskModeDoor*)pTask)->GetDestPXY( &iDP , &iDX , &iDY ) ;	
			GL::pFODSS->GetRoomParameter( &ucRW , NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL ) ;

			int itx , ity ;
			itx = iDX + iDP%ucRW*FODS_CHIP_P_PAGE_W ;
			ity = iDY + iDP/ucRW*FODS_CHIP_P_PAGE_H ;
			itx = iX + itx * FODS_TILE_SIZE ;
			ity = iY + ity * FODS_TILE_SIZE ;
			GL::mdo.Cls( MDO3WINAPI , GL::SFC_BACK , itx   , ity   , FODS_TILE_SIZE   , FODS_TILE_SIZE   , myRGB(31,16,0) ) ;
			GL::mdo.Cls( MDO3WINAPI , GL::SFC_BACK , itx+1 , ity+1 , FODS_TILE_SIZE-2 , FODS_TILE_SIZE-2 , myRGB(31,31,0) ) ;
		}
	}
}
