
#include "../common.h"


void TaskModeObj::Finit()
{
	Task0810 *pTask ;
	hBinaryEditor = 0 ;
	hRotateList = 0 ;
	iEditingValue = 0 ;
	pTask = new TaskObjectBinaryEditor( this , true , 0 , GL::WINHEIGHT-32 , 32 , (unsigned char *)&iEditingValue , 1 ,  1 , 1 ) ;
	if( pTask )
		{ hBinaryEditor = pTask->GetHandle() ; }
	pTask = new TaskObjectRotateList( this , true , GL::WINWIDTH-256 , 0 , 256 , 14 , 31 , &iEditingValue , GL::astrObjectName , 256 ) ;
	if( pTask )
		{ hRotateList = pTask->GetHandle() ; }
	GL::pFODSW->ObjUnit.InitEditing() ;
	SetProcessOrderPandC( false , true ) ;
	SetDrawOrderPandC( true , false ) ;
	return ;
}
void TaskModeObj::Fmain()
{
	Task0810 *pTask ;
	bool bUpdate = false ;
	pTask = Task0810::SolveHandle( hBinaryEditor ) ;
	if( pTask )
	{
		bUpdate = bUpdate | ((TaskObjectBinaryEditor*)pTask)->IsChanged() ;
	}
	pTask = Task0810::SolveHandle( hRotateList ) ;
	if( pTask )
	{
		bUpdate = bUpdate | ((TaskObjectRotateList*)pTask)->IsChanged() ;
	}
	if( bUpdate )
	{
		GL::pFODSW->ObjUnit.Modify( -1 , -1 , iEditingValue ) ;
		GL::iUpdatedRoom |= GL::pFODSW->IsObjPooled() ;
		GL::RequestRedraw() ;
	}

	int iX , iY ;
	Task0810::GetGlobalPosition( &iX , &iY , 2 ) ;
	if( GL::pFODSW->ObjUnit.DoEdit( iX , iY ) )
	{
		GL::iUpdatedRoom |= GL::pFODSW->IsObjPooled() ;
		GL::RequestRedraw() ;
	}

	{
		int iTmp ;
		iTmp = GL::pFODSW->ObjUnit.GetType() ;
		if( iTmp >= 0 && iTmp != iEditingValue )
		{
			iEditingValue = iTmp ;
			GL::RequestRedraw() ;
		}
	}

	return ;
}
void TaskModeObj::Fdest()
{
	return ;
}
void TaskModeObj::Fdraw()
{
	int iX , iY ;
	Task0810::GetGlobalPosition( &iX , &iY , 2 ) ;
	GL::pFODSW->ObjUnit.Draw( &GL::mdo , GL::SFC_BACK , iX , iY ) ;
	if( !GL::pFODSW->IsObjPooled() )
	{
		GL::BoxMoji( GL::SFC_BACK , _T("Object in this room non-pooled") ,
			10 , GL::WINHEIGHT/2-24 , 24 , 12 , RGB(255,255,255) ) ;
		GL::BoxMoji( GL::SFC_BACK , _T("Cannot save") ,
			10 , GL::WINHEIGHT/2  , 24 , 12 , RGB(255,255,255) ) ;
	}
	{
		_TCHAR atcTmp[128] ;
		_stprintf_s( atcTmp , _countof(atcTmp) , _T("Object mode Room:%03d[%03X]") , GL::iCurRoom , GL::iCurRoom ) ;
		SetWindowText( GL::hWnd , atcTmp ) ;
	}
	return ;
}
