#ifndef TEXT_INPUT_OUTPUT_HEADER_INCLUDED
#define TEXT_INPUT_OUTPUT_HEADER_INCLUDED

#include <windows.h>
#include <tchar.h>
#include <stdio.h>


typedef struct TextIOItem_tag
{
	int mode ;
	LPTSTR token ;
	void *Pdata ;
	int size ;
} TextIOItem ;

class TextIOManager
{
private:
	//R}hɂs̈
	_TCHAR command_token ;
	//Rgɂs̈
	_TCHAR comment_token ;
	//o͂t@C
	LPCTSTR filename ;
	//hnACẽobt@iCX^X쐬ɊmیAŒj
	TextIOItem *PItem ;
	//hnACel߂Ăʒu
	int itempos ;
	//hnACe̍ő吔
	int maxitem ;
public:
	TextIOManager::TextIOManager( LPCTSTR filename , int NOIOItem , _TCHAR command_token , _TCHAR comment_token );
	TextIOManager::~TextIOManager() ;
/*
	ȉ̊֐Ńf[^ɓKȖOig[NjĎw肷邪
	ꂼŗL̖OłKvA
	܂AuBINv͎gĂ͂ȂAXy[X^u܂ł͂ȂB
*/
	//KȃRgiZ[uɗLj
	bool AddIOItem_Comment( LPCTSTR token ) ;
	//PUrbg̒lBint^Ŏ󂯂B
	bool AddIOItem_16Value( LPCTSTR token , int *Pval ) ;
	//ubNBKȌ^Ŏ󂯂B
	bool AddIOItem_Block( LPCTSTR token , void *Pblock , int size ) ;
	//PUrbg̒l̘ABint^Ŏ󂯂B
	bool AddIOItem_16Array( LPCTSTR token , int *Pval , int size ) ;
	//Z[us
	int DoSaving() ;
	//[hs
	int DoLoading() ;
};


#endif /*TEXT_INPUT_OUTPUT_HEADER_INCLUDED*/

