#ifndef _6502_M_MACRO_HEADER_INCLUDED
#define _6502_M_MACRO_HEADER_INCLUDED

#define		FLAG_C		0x01
#define		FLAG_Z		0x02
#define		FLAG_I		0x04
#define		FLAG_D		0x08
#define		FLAG_B		0x10
#define		FLAG_V		0x40
#define		FLAG_N		0x80

#define		SET_F(fl)		(Pd->reg.p|=(fl))
#define		CLR_F(fl)		(Pd->reg.p&=~(fl))
#define		IS_SET_F(fl)	(Pd->reg.p&(fl))
#define		IS_CLR_F(fl)	((Pd->reg.p&(fl))==0)

#define		PCLEAR		{CLR_F(FLAG_Z|FLAG_V|FLAG_N);}

#define		TEST(num)	{PCLEAR; if(!num)SET_F(FLAG_Z);if(num&0x80)SET_F(FLAG_N);}

#define		TESTX()	{TEST(Pd->reg.x);}
#define		TESTY()	{TEST(Pd->reg.y);}
#define		TESTA()	{TEST(Pd->reg.a);}

#endif _6502_M_MACRO_HEADER_INCLUDED


