//RTI
static void OP40( DataSet* Pd )
{
	throw EMSG_UKOP ;	
}

//EOR ($**,x)
static void OP41( DataSet* Pd )
{
	EOR( Pd , READ( Pd , IndirectX( Pd ) ) ) ;
}

//EOR $**
static void OP45( DataSet* Pd )
{
	EOR( Pd , READ( Pd , Zeropage( Pd ) ) ) ;
	
}

//LSR $**
static void OP46( DataSet* Pd )
{
	LSR( Pd , GetMemoryPointer( Pd , Zeropage( Pd ) ) ) ;
	
}

//PHA
static void OP48( DataSet* Pd )
{
	PHA( Pd );
	
}

//EOR #$**
static void OP49( DataSet* Pd )
{
	EOR( Pd , Immediate8( Pd ) ) ;
	
}

//LSR A
static void OP4A( DataSet* Pd )
{
	LSR( Pd , &Pd->reg.a ) ;	
}

//JMP
static void OP4C( DataSet* Pd )
{
	JMP( Pd , Immediate16(Pd) );
}

//EOR $****
static void OP4D( DataSet* Pd )
{
	EOR( Pd , READ( Pd , AbsoluteAddress( Pd ) ) ) ;
	
}

//LSR $****
static void OP4E( DataSet* Pd )
{
	LSR( Pd , GetMemoryPointer( Pd , AbsoluteAddress( Pd ) ) ) ;
	
}

//bvc
static void OP50( DataSet* Pd )
{
BYTE tb=Immediate8(Pd);
	if( !(Pd->reg.p & FLAG_V) )
		Pd->reg.pc += (char)tb;
	
}

//EOR ($**),y
static void OP51( DataSet* Pd )
{
	EOR( Pd , READ( Pd , IndirectY( Pd ) ) ) ;
	
}

//EOR $**,x
static void OP55( DataSet* Pd )
{
	EOR( Pd , READ( Pd , ZeropageIndexX( Pd ) ) ) ;
	
}

//LSR $**,x
static void OP56( DataSet* Pd )
{
	LSR( Pd , GetMemoryPointer( Pd , ZeropageIndexX( Pd ) ) ) ;
	
}

//CLI
static void OP58( DataSet* Pd )
{
	CLR_F( FLAG_I );
	
}

//EOR $****,y
static void OP59( DataSet* Pd )
{
	EOR( Pd , READ( Pd , AbsoluteAddressIndexY( Pd ) ) ) ;
	
}

//EOR $****,x
static void OP5D( DataSet* Pd )
{
	EOR( Pd , READ( Pd , AbsoluteAddressIndexX( Pd ) ) ) ;
	
}

//LSR $****,x
static void OP5E( DataSet* Pd )
{
	LSR( Pd , GetMemoryPointer( Pd , AbsoluteAddressIndexX( Pd ) ) ) ;
	
}

//rts
static void OP60( DataSet* Pd )
{
	RTS( Pd );
	
}

//ADC ($**,x)
static void OP61( DataSet* Pd )
{
	ADC( Pd , READ( Pd , IndirectX( Pd ) ) ) ;
}


//ADC $**
static void OP65( DataSet* Pd )
{
	ADC( Pd , READ( Pd , Zeropage(Pd)) );
	
}

//ROR $**
static void OP66( DataSet* Pd )
{
	ROR( Pd , GetMemoryPointer( Pd , Zeropage( Pd ) ) ) ;
	
}

//PLA
static void OP68( DataSet* Pd )
{
	PLA( Pd );
	
}

//ADC #$**
static void OP69( DataSet* Pd )
{
	ADC( Pd , Immediate8( Pd ) );
	
}

//ROR A
static void OP6A( DataSet* Pd )
{
	ROR( Pd , &Pd->reg.a ) ;
}

//JMP ($****)
static void OP6C( DataSet* Pd )
{
	JMP( Pd , Indirect( Pd ) ) ;
}
//ADC $****
static void OP6D( DataSet* Pd )
{
	ADC( Pd , READ( Pd , AbsoluteAddress( Pd ) ) ) ;
	
}

//ROR $****
static void OP6E( DataSet* Pd )
{
	ROR( Pd , GetMemoryPointer( Pd , AbsoluteAddress( Pd ) ) ) ;
	
}

//bvs
static void OP70( DataSet* Pd )
{
BYTE tb=Immediate8(Pd);
	if( Pd->reg.p & FLAG_V )
		Pd->reg.pc += (char)tb;
	
}

//ADC ($**),y
static void OP71( DataSet* Pd )
{
	ADC( Pd , READ( Pd , IndirectY( Pd ) ) ) ;
	
}

//ADC $**,x
static void OP75( DataSet* Pd )
{
	ADC( Pd , READ( Pd , ZeropageIndexX( Pd ) ) ) ;
	
}
//ROR $**,x
static void OP76( DataSet* Pd )
{
	ROR( Pd , GetMemoryPointer( Pd , ZeropageIndexX( Pd ) ) ) ;
	
}

//SEI
static void OP78( DataSet* Pd )
{
	SET_F( FLAG_I );
	
}

//ADC $****,y
static void OP79( DataSet* Pd )
{
	ADC( Pd , READ( Pd , AbsoluteAddressIndexY( Pd ) ) ) ;
	
}


//ADC $****,x
static void OP7D( DataSet* Pd )
{
	ADC( Pd , READ( Pd , AbsoluteAddressIndexX( Pd ) ) ) ;
	
}
//ROR $****,x
static void OP7E( DataSet* Pd )
{
	ROR( Pd , GetMemoryPointer( Pd , AbsoluteAddressIndexX( Pd ) ) ) ;
	
}
