//CPY #$**
static void OPC0( DataSet* Pd )
{
	CPY( Pd , Immediate8( Pd ) ) ;
}

//CMP ($**,x)
static void OPC1( DataSet* Pd )
{
	CMP( Pd , READ( Pd , IndirectX( Pd ) ) ) ;
	
}

//CPY $**
static void OPC4( DataSet* Pd )
{
	CPY( Pd , READ( Pd , Zeropage( Pd ) ) ) ;
	
}
//CMP $**
static void OPC5( DataSet* Pd )
{
	CMP( Pd , READ( Pd , Immediate8( Pd ) ) );
	
}

//DEC $**
static void OPC6( DataSet* Pd )
{
	DEC( Pd , Immediate8( Pd ) );
	
}

//INY
static void OPC8( DataSet* Pd )
{
	INY( Pd );
	
}

//CMP #$**
static void OPC9( DataSet* Pd )
{
	CMP( Pd , Immediate8(Pd) );
	
}

//DEX
static void OPCA( DataSet* Pd )
{
	DEX( Pd );
	
}

//CPY $****
static void OPCC( DataSet* Pd )
{
	CPY( Pd , READ( Pd , AbsoluteAddress( Pd ) ) ) ;
	
}
//CMP $****
static void OPCD( DataSet* Pd )
{
	CMP( Pd , READ( Pd , AbsoluteAddress( Pd ) ) ) ;
	
}

//DEC $****
static void OPCE( DataSet* Pd )
{
	DEC( Pd , AbsoluteAddress( Pd ) ) ;
	
}
//BNE
static void OPD0( DataSet* Pd )
{
BYTE tb=Immediate8(Pd);
	if( !(Pd->reg.p & FLAG_Z) )
		Pd->reg.pc += (char)tb;
	
}
//CMP ($**),y
static void OPD1( DataSet* Pd )
{
	CMP( Pd , READ( Pd , IndirectY( Pd ) ) ) ;
	
}

//CMP $**,X
static void OPD5( DataSet* Pd )
{
	CMP( Pd , READ( Pd , ZeropageIndexX( Pd ) ) ) ;
	
}

//DEC $**,x
static void OPD6( DataSet* Pd )
{
	DEC( Pd , ZeropageIndexX( Pd ) ) ;
	
}

//CLD
static void OPD8( DataSet* Pd )
{
	CLR_F( FLAG_D );
	
}

//CMP $****,y
static void OPD9( DataSet* Pd )
{
	CMP( Pd , READ( Pd , AbsoluteAddressIndexY( Pd ) ) ) ;
	
}


//CMP $****,x
static void OPDD( DataSet* Pd )
{
	CMP( Pd , READ( Pd , AbsoluteAddressIndexX( Pd ) ) ) ;
	
}

//DEC $****,x
static void OPDE( DataSet* Pd )
{
	DEC( Pd , AbsoluteAddressIndexX( Pd ) ) ;
	
}

//CPX #$**
static void OPE0( DataSet* Pd )
{
	CPX( Pd , Immediate8( Pd ) );
}
//SBC ($**,x)
static void OPE1( DataSet* Pd )
{
	SBC( Pd , READ( Pd , IndirectX( Pd ) ) ) ;
	
}


//CPX $**
static void OPE4( DataSet* Pd )
{
	CPX( Pd , READ( Pd , Zeropage( Pd ) ) ) ;
	
}

//SBC $**
static void OPE5( DataSet* Pd )
{
	SBC( Pd , Zeropage( Pd ) ) ;
	
}

//INC $**
static void OPE6( DataSet* Pd )
{
	INC( Pd , Immediate8( Pd ) ) ;
	
}

//INX
static void OPE8( DataSet* Pd )
{
	INX( Pd );
	
}

//SBC #$**
static void OPE9( DataSet* Pd )
{
	SBC( Pd , Immediate8(Pd) );
	TESTA();
	
}

static void OPEA( DataSet* Pd )
{
//DȁANOP
	
}

//CPX $****
static void OPEC( DataSet* Pd )
{
	CPX( Pd , READ( Pd , AbsoluteAddress( Pd ) ) ) ;
	
}
//SBC $****
static void OPED( DataSet* Pd )
{
	SBC( Pd , READ( Pd , AbsoluteAddress( Pd ) ) ) ;
	
}
//INC $****
static void OPEE( DataSet* Pd )
{
	INC( Pd , AbsoluteAddress( Pd ) ) ;
	
}

//BEQ
static void OPF0( DataSet* Pd )
{
BYTE tb=Immediate8(Pd);
	if( Pd->reg.p & FLAG_Z )
		Pd->reg.pc += (char)tb;
	
}
//SBC ($**),y
static void OPF1( DataSet* Pd )
{
	SBC( Pd , READ( Pd , IndirectY( Pd ) ) ) ;
	
}

//SBC $**,x
static void OPF5( DataSet* Pd )
{
	SBC( Pd , READ( Pd , ZeropageIndexX( Pd ) ) ) ;
	
}


//INC $**,x
static void OPF6( DataSet* Pd )
{
	INC( Pd , ZeropageIndexX( Pd ) ) ;
	
}

//SED
static void OPF8( DataSet* Pd )
{
	SET_F( FLAG_D );
	
}
//SBC $****,y
static void OPF9( DataSet* Pd )
{
	SBC( Pd , READ( Pd , AbsoluteAddressIndexY( Pd ) ) ) ;
	
}

//SBC $****,x
static void OPFD( DataSet* Pd )
{
	SBC( Pd , READ( Pd , AbsoluteAddressIndexX( Pd ) ) ) ;
	
}
//INC $****,x
static void OPFE( DataSet* Pd )
{
	INC( Pd , AbsoluteAddressIndexX( Pd ) ) ;
	
}
