#ifndef _6502M_PRIVATE_HEADER_INCLUDED
#define _6502M_PRIVATE_HEADER_INCLUDED

#define		ERNO_ND			0x10
#define		ERNO_UKOP		0x11
#define		ERNO_EOS		0x20
#define		ERNO_STACK_N	0x21
#define		ERNO_STACK_O	0x22
#define		ERNO_ROM_WRITE	0x40
#define		ERNO_BREAK		0x70
#define		ERNO_TRIAL_OUT	0x71

#define		EMSG_ND			"\x10Undefined instruction execution"
#define		EMSG_UKOP		"\x11Potentially abnormal instruction execution"
#define		EMSG_EOS		"\x20Normal return"
#define		EMSG_STACK_N	"\x21Stack error"
#define		EMSG_STACK_O	"\x22Stack overflow"

#define		EMSG_ROM_WRITE	"\x40Tried to write ROM on strange location"

#define		EMSG_BREAK		"\x70Break"
#define		EMSG_TRIAL_OUT	"\x71Too many trials. Instruction break"

#endif /*_6502M_PRIVATE_HEADER_INCLUDED*/