#ifndef KEYCODE_HEADER_INCLUDED
#define KEYCODE_HEADER_INCLUDED

/*
	[ȃL[R[h萔B
*/

enum KeyCode
{
	KC_NONE ,
	KC_BACKSPACE	=	8	,
	KC_TAB			=	9	,
	KC_ENTER		=	13	,
	KC_SHIFT		=	16	,
	KC_CTRL			=	17	,
	KC_ESC			=	27	,
	KC_SPACE		=	32	,
	KC_PAGEUP		=	33	,
	KC_PAGEDOWN		=	34	,
	KC_END			=	35	,
	KC_HOME			=	36	,
	KC_AL			=	37	,
	KC_AU,
	KC_AR,
	KC_AD,
	KC_INS			=	45	,
	KC_DEL			=	46	,
	KC_0			=	48	,
	KC_1			=	49	,
	KC_2			=	50	,
	KC_3			=	51	,
	KC_4			=	52	,
	KC_5			=	53	,
	KC_6			=	54	,
	KC_7			=	55	,
	KC_8			=	56	,
	KC_9			=	57	,
	/*
	KC_COLON		=	58	,
	KC_SEMICOLON	=	59	,
	KC_LESSTHAN		=	60	,
	KC_EQUAL		=	61	,
	KC_MORETHAN		=	62	,
	KC_QUESTION		=	63	,
	KC_AT			=	64	,
	*/
	KC_A			=	65	,
	KC_B			=	66	,
	KC_C			=	67	,
	KC_D			=	68	,
	KC_E			=	69	,
	KC_F			=	70	,
	KC_G			=	71	,
	KC_H			=	72	,
	KC_I			=	73	,
	KC_J			=	74	,
	KC_K			=	75	,
	KC_L			=	76	,
	KC_M			=	77	,
	KC_N			=	78	,
	KC_O			=	79	,
	KC_P			=	80	,
	KC_Q			=	81	,
	KC_R			=	82	,
	KC_S			=	83	,
	KC_T			=	84	,
	KC_U			=	85	,
	KC_V			=	86	,
	KC_W			=	87	,
	KC_X			=	88	,
	KC_Y			=	89	,
	KC_Z			=	90	,
	KC_NUM0			=	96	,
	KC_NUM1,
	KC_NUM2,
	KC_NUM3,
	KC_NUM4,
	KC_NUM5,
	KC_NUM6,
	KC_NUM7,
	KC_NUM8,
	KC_NUM9,
	KC_NUMCROSS		=	106	,
	KC_NUMPLUS,
	KC_NUMMINUS		=	109	,
	KC_NUMPERIOD,
	KC_NUMSLASH,
	KC_F1			=	112	,
	KC_F2,
	KC_F3,
	KC_F4,
	KC_F5,
	KC_F6,
	KC_F7,
	KC_F8,
	KC_F9,
	KC_F10,
	KC_F11,
	KC_F12,
	KC_COLON		=	186	,
	KC_SEMICOLON	=	187	,
	KC_COMMA		=	188	,
	KC_MINUS		=	189	,
	KC_PERIOD		=	190	,
	KC_SLASH		=	191	,
	KC_AT			=	192	,
	KC_YEN			=	220 ,
	KC_HAT			=	222 ,
};







#endif /* KEYCODE_HEADER_INCLUDED */