#ifndef PACKING_EX_HEADER_INCLUDED
#define PACKING_EX_HEADER_INCLUDED

#include "packing.h"
#include "typedfunction.h"

class PackingEX : public Packing
{
public:
	PackingEX() {;}
	~PackingEX() {;}

	void OutputFreeSpaceInfo( tofstream &oOS )
	{
		_TCHAR atcTmp[64] ;
		int iTotal = 0 ;
		for( int i=0 ; ; i++ )
		{
			Packing_FreeSpace *pTmp ;
			pTmp = cvFree[i] ;
			if( !pTmp ){break ;}
			_stprintf_s( atcTmp , _countof(atcTmp) , _T("Offset:%06X Size:%X") , pTmp->iOffset , pTmp->iSize ) ;
			oOS << atcTmp << std::endl ;
			iTotal += pTmp->iSize ;
		}
		_stprintf_s( atcTmp , _countof(atcTmp) , _T("Total:%X") , iTotal ) ;
		oOS << atcTmp << std::endl ;
	}
	void OutputPackDataInfo( tofstream &oOS )
	{
		_TCHAR atcTmp[64] ;
		int iTotal = 0 ;
		for( int i=0 ; ; i++ )
		{
			PackingData *pTmp ;
			pTmp = cvPacking[i] ;
			if( !pTmp ){break ;}
			_stprintf_s( atcTmp , _countof(atcTmp) , _T("Size:%X") , pTmp->iSize ) ;
			oOS << atcTmp << std::endl ;
			iTotal += pTmp->iSize ;
		}
		_stprintf_s( atcTmp , _countof(atcTmp) , _T("Total:%X") , iTotal ) ;
		oOS << atcTmp << std::endl ;
	}
protected:
	virtual unsigned int Offset2Addr( int iOffset )
	{ 
		return ((iOffset/0x2000)<<16) |
				(0xA000 | (iOffset&0x1FFF) ) ;
	}
};

#endif /*PACKING_EX_HEADER_INCLUDED*/
